# class Gem::Commands::PushCommand

### Public Class Methods

new() click to toggle source
Calls superclass method `Gem::Command::new`

    # File lib/rubygems/commands/push_command.rb, line 32
    def initialize
      super "push", "Push a gem up to the gem server", :host => self.host

      @user_defined_host = false

      add_proxy_option
      add_key_option
      add_otp_option

      add_option("--host HOST",
                 "Push to another gemcutter-compatible host",
                 "  (e.g. https://rubygems.org)") do |value, options|
        options[:host] = value
        @user_defined_host = true
      end

      @host = nil
    end

### Public Instance Methods

execute() click to toggle source

    # File lib/rubygems/commands/push_command.rb, line 51
    def execute
      gem_name = get_one_gem_name
      default_gem_server, push_host = get_hosts_for(gem_name)

      @host = if @user_defined_host
        options[:host]
      elsif default_gem_server
        default_gem_server
      elsif push_host
        push_host
      else
        options[:host]
      end

      sign_in @host, scope: get_push_scope

      send_gem(gem_name)
    end

send_gem(name) click to toggle source

    # File lib/rubygems/commands/push_command.rb, line 70
    def send_gem(name)
      args = [:post, "api/v1/gems"]

      _, push_host = get_hosts_for(name)

      @host ||= push_host

      # Always include @host, even if it's nil
      args += [ @host, push_host ]

      say "Pushing gem to #{@host || Gem.host}..."

      response = send_push_request(name, args)

      with_response response
    end

### Private Instance Methods

get_hosts_for(name) click to toggle source

    # File lib/rubygems/commands/push_command.rb, line 98
    def get_hosts_for(name)
      gem_metadata = Gem::Package.new(name).spec.metadata

      [
        gem_metadata["default_gem_server"],
        gem_metadata["allowed_push_host"],
      ]
    end

get_push_scope() click to toggle source

    # File lib/rubygems/commands/push_command.rb, line 107
    def get_push_scope
      :push_rubygem
    end

send_push_request(name, args) click to toggle source

    # File lib/rubygems/commands/push_command.rb, line 89
    def send_push_request(name, args)
      rubygems_api_request(*args, scope: get_push_scope) do |request|
        request.body = Gem.read_binary name
        request.add_field "Content-Length", request.body.size
        request.add_field "Content-Type",   "application/octet-stream"
        request.add_field "Authorization",  api_key
      end
    end